/********************************** (C) COPYRIGHT *******************************
 * File Name          : ch32v10x_it.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2020/04/30
 * Description        : Main Interrupt Service Routines.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/
#include  "ch32v10x_it.h"
#include  "system_mcu_set.h"
#include  "function_project.h"


void NMI_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void HardFault_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));


void TIM3_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void ADC1_2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

void TIM3_IRQHandler(void)
{
    #if( TIM3_STATUS == TIM3_ENABLE )


        if(TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET) //检查TIM3中断是否发生。
        {
            TIM_ClearITPendingBit(TIM3,TIM_IT_Update);    //清除TIM3的中断挂起位。

            Time_Base_Add();
			
			Adc_Isr_Start_Fun();
        }
    #endif
}

//ADC中断服务函数
void ADC1_2_IRQHandler(void)
{
    if (ADC_GetITStatus(ADC1,ADC_IT_EOC)==SET)
    {
       Adc_Isr_Get_Fun();
    }
    // ADC_ClearITPendingBit(ADC1,ADC_IT_EOC);
}


/*********************************************************************
 * @fn      NMI_Handler
 *
 * @brief   This function handles NMI exception.
 *
 * @return  none
 */
void NMI_Handler(void)
{
//    static unsigned char pin_sta = 0;

//	#if( TIM3_STATUS == TIM3_ENABLE )

//		if(TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET) //检查TIM3中断是否发生。
//		{
//			TIM_ClearITPendingBit(TIM3,TIM_IT_Update);    //清除TIM3的中断挂起位。
//
//			   if( pin_sta )
//			   {
//			       pin_sta = 0;
//                    GPIO_SetBits(  GPIOB , GPIO_Pin_13  );
//                    GPIO_SetBits(  GPIOB , GPIO_Pin_14  );
//                    GPIO_SetBits(  GPIOB , GPIO_Pin_15  );
//			   }
//			   else
//			   {
//			       pin_sta = 1;
//                    GPIO_ResetBits( GPIOB , GPIO_Pin_13 );
//                    GPIO_ResetBits( GPIOB , GPIO_Pin_14 );
//                    GPIO_ResetBits( GPIOB , GPIO_Pin_15 );
//			   }
//
//		}

//	#endif
	
}

/*********************************************************************
 * @fn      HardFault_Handler
 *
 * @brief   This function handles Hard Fault exception.
 *
 * @return  none
 */
void HardFault_Handler(void)
{
  while (1)
  {
  }
}


