/**************************************************************************//**

 ******************************************************************************/

#include "function_oz9350.h"


	struct OZ9350_ST  OZ9350;


	//******************************************************************************************
	// name       :    IIC_DELAY
	// function   : 
	// definition : 
	//******************************************************************************************
	void OZ9350_IIC_Delay( unsigned char delay_time )
	{
		while( delay_time-- )
		{
			__NOP();
		};
	}

	//******************************************************************************************
	// name       :    IIC_SART
	// function   : 
	// definition : 
	//******************************************************************************************
	void OZ9350_IIC_Start( void )
	{
		OZ9350_SDA_HIGHT;
		OZ9350_SCK_HIGHT;
		
		OZ9350_IIC_Delay( OZ9350_DELAY_M );
		OZ9350_SDA_LOW;
		
		OZ9350_IIC_Delay( OZ9350_DELAY_M );
		OZ9350_SCK_LOW;
		
		OZ9350_IIC_Delay( OZ9350_DELAY_M );	
	}
	
	//******************************************************************************************
	// name       :  IIC_STOP
	// function   :   
	// definition :  
	//******************************************************************************************
	void OZ9350_IIC_Stop( void )
	{
		OZ9350_SDA_LOW;
		
		OZ9350_SCK_HIGHT;
		
		OZ9350_IIC_Delay( OZ9350_DELAY_M );

		OZ9350_SDA_HIGHT;
		
		OZ9350_IIC_Delay( OZ9350_DELAY_M );
	}
	
	 //******************************************************************************************
	 // name       :  OZ9350_IIC_Write_Byte 写一个字节的数据
	 // function   :
	 // definition :
	 //******************************************************************************************
	 void OZ9350_IIC_Write_Byte( unsigned char wr_data )
	 {
		 unsigned char i = 0;
		
		 for( i = 0; i < 8; i++ )
		 {
			 OZ9350_SCK_LOW;
			
			 OZ9350_IIC_Delay( OZ9350_DELAY_L );
			
			 if( wr_data & 0x80 )
			 {
				 OZ9350_SDA_HIGHT;
			 }
			 else
			 {
				 OZ9350_SDA_LOW;
			 }
			
			 OZ9350_IIC_Delay( OZ9350_DELAY_M );
			
			 OZ9350_SCK_HIGHT;
			
			 OZ9350_IIC_Delay( OZ9350_DELAY_H );

			
			 OZ9350_SCK_LOW;
		
			 wr_data <<= 1;

			 OZ9350_IIC_Delay( OZ9350_DELAY_L );
			
		 }
		
		 OZ9350_SDA_HIGHT;	// 释放总线
	 }
	
	 //******************************************************************************************
	 // name       :  OZ9350_IIC_Read_Byte 读取一个字节数据
	 // function   :
	 // definition :
	 //******************************************************************************************
	 unsigned char OZ9350_IIC_Read_Byte( void )
	 {
		 unsigned char i = 0;
		 unsigned char get_data = 0;
	
		// OZ9350_SDA_Input_Mode();
		
		 OZ9350_SCK_LOW;
		
		 for(  i = 0; i < 8; i++ )
		 {
			 OZ9350_IIC_Delay( OZ9350_DELAY_M );
			
			 get_data <<= 1;
			
			 OZ9350_SCK_HIGHT;
			 OZ9350_IIC_Delay( OZ9350_DELAY_M );
			
//			 if( GPIO_ReadInputDataBit( GPIOA, GPIO_Pin_4 ) )
//			 {
//				 get_data |= 0X01;
//			 }
			
			 OZ9350_SCK_LOW;
			 OZ9350_IIC_Delay( OZ9350_DELAY_M );
			
		 }
		
//		 OZ9350_SDA_Out_Mode();
		
		 return get_data;
		
	 }
	

	//******************************************************************************************
	// name       :  OZ9350_Sen_Ack_Nack  
	// function   :  发送 ACK NACK 信号
	// definition :  
	//******************************************************************************************
	void OZ9350_Sen_Ack_Nack( unsigned char ack_mes )
	{
		if( ack_mes == ACK_SEN )
		{
			OZ9350_SDA_LOW;
		}
		else if( ack_mes == NACK_SEN )
		{
			OZ9350_SDA_HIGHT;
		}
		

		OZ9350_IIC_Delay( OZ9350_DELAY_M );

		OZ9350_SCK_HIGHT;

		OZ9350_IIC_Delay( OZ9350_DELAY_M );

		OZ9350_SCK_LOW;

		OZ9350_IIC_Delay( OZ9350_DELAY_M );

		if( ack_mes == ACK_SEN )
		{
			OZ9350_SDA_HIGHT;
		}
		
	}	
	
	
	//******************************************************************************************
	// name       :  获取 ACK 应答信号
	// function   :   
	// definition :  
	//******************************************************************************************
	unsigned char OZ9350_Get_Ack( void )
	{
		unsigned char ack_mes = 0;
		
		// SDA 输入模式
		OZ9350_SDA_Input_Mode();
		
		OZ9350_IIC_Delay( OZ9350_DELAY_M );
		
		OZ9350_SCK_HIGHT;
		
		OZ9350_IIC_Delay( OZ9350_DELAY_M );

		
		if( GPIO_ReadInputDataBit( GPIOA, GPIO_Pin_4 ) )
		{
			ack_mes = 0;
		}
		else
		{
			ack_mes = 1;
		}

		OZ9350_SCK_LOW;
		
		OZ9350_IIC_Delay( OZ9350_DELAY_H );
		
		// SDA 输出模式
		OZ9350_SDA_Out_Mode();
		OZ9350_SDA_HIGHT;
		
		OZ9350_IIC_Delay( OZ9350_DELAY_H );
		return ack_mes;
		
	}	
	
	
	//******************************************************************************************
	// name       :  SDA 上拉输入
	// function   :   
	// definition :  
	//******************************************************************************************
	void OZ9350_SDA_Input_Mode(void)
	{
	    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);

		GPIO_InitTypeDef GPIO_InitStructure = {0};

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_Init(GPIOA, &GPIO_InitStructure);

	}
	
	//******************************************************************************************
	// name       :   SDA 输出模式
	// function   :   开漏输出
	// definition :  
	//******************************************************************************************	
	void OZ9350_SDA_Out_Mode(void)
	{
	    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);

		GPIO_InitTypeDef GPIO_InitStructure = {0};

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_Init(GPIOA, &GPIO_InitStructure);

	}
	
	

	//******************************************************************************************
	// name       :   SDA 输出模式
	// function   :   开漏输出
	// definition :  
	//******************************************************************************************		
	void OZ9350_Read_Register( unsigned char Read_Address  )
	{
		// 起始 - 从机地址+读 - ACK
		// 寄存器地址 +  ACK
		// 起始 - 从机地址+读 - ACK
		// 读1字节数据        - ACK
		// 读1字节CRC		  - NACK
		// STOP
		unsigned char Get_Ack  = 0;
		unsigned char Get_data = 0;
		unsigned char Get_Crc  = 0;
		
		unsigned char Caculate_Crc[2];
		
		
		OZ9350_IIC_Start();
		
		OZ9350_IIC_Write_Byte( OZ9350_ADR | READ_CMD );
		Get_Ack = OZ9350_Get_Ack();
		if( Get_Ack == 0 )		// 
		
        OZ9350_IIC_Write_Byte(  0x00  );
        Get_Ack = OZ9350_Get_Ack();
        if( Get_Ack == 0 )      //

		OZ9350_IIC_Start();

		OZ9350_IIC_Write_Byte( OZ9350_ADR | READ_CMD );
		Get_Ack = OZ9350_Get_Ack();
		if( Get_Ack == 0 )		//


		Get_data = OZ9350_IIC_Read_Byte( );
		OZ9350_Sen_Ack_Nack( ACK_SEN );

		Get_Crc = OZ9350_IIC_Read_Byte( );
		OZ9350_Sen_Ack_Nack( NACK_SEN );
		OZ9350_IIC_Stop();
//
//
//		Caculate_Crc[0] = Read_Address;
//		Caculate_Crc[1] = Get_data;
		
		OZ9350.Register_Get_Mess[ Read_Address ] = Get_data;
		OZ9350.Register_Get_Crc[ Read_Address ]  = Get_Crc;
		OZ9350.Register_Caculat_Crc[ Read_Address ] = OZ9350_CalcCrc( &Caculate_Crc[0] ,2 );
	}
	
	//******************************************************************************************
	// name       :   SDA 输出模式
	// function   :   开漏输出
	// definition :  
	//******************************************************************************************		
	void OZ9350_Write_Register( unsigned char Write_Address , unsigned char Write_Data  )
	{
		// 起始 - 从机地址+写 - 读ACK
		// 寄存器地址   	  - 读ACK
		// 写1字节数据        - 读ACK
		// 写1字节CRC		  - 读ACK
		// STOP
		unsigned char Get_Ack  = 0;
		unsigned char Sen_Crc  = 0;
		
		OZ9350_IIC_Start();
		
		OZ9350_IIC_Write_Byte( OZ9350_ADR | WRITE_CMD );
		
		Get_Ack = OZ9350_Get_Ack();
		if( Get_Ack == 0 )		// 
		
		OZ9350_IIC_Write_Byte( Write_Address );
		
		Get_Ack = OZ9350_Get_Ack();
		if( Get_Ack == 0 )		// 		
		
		OZ9350_IIC_Write_Byte( Write_Data );
		
		Get_Ack = OZ9350_Get_Ack();
		if( Get_Ack == 0 )		// 

		OZ9350_IIC_Write_Byte( Sen_Crc );
		
		Get_Ack = OZ9350_Get_Ack();
		if( Get_Ack == 0 )		// 
		
		OZ9350_IIC_Stop();

		// OZ9350.Register_Get_Mess[ Read_Address ] = Get_data;
		// OZ9350.Register_Get_Crc[ Read_Address ]  = Get_Crc;
	}	
	



	unsigned char OZ9350_CalcCrc( unsigned char data_buff[], unsigned char nbrOfBytes )
	{
	  unsigned char bit;        // bit mask
	  unsigned char crc = 0xFF; // calculated checksum
	  unsigned char byteCtr;    // byte counter
	  
	  // calculates 8-Bit checksum with given polynomial
	  for( byteCtr = 0; byteCtr < nbrOfBytes; byteCtr++ )
	  {
		crc ^= ( data_buff[ byteCtr ] );
		for( bit = 8; bit > 0; --bit )
		{
		  if( crc & 0x80 ) crc = ( crc << 1 ) ^ POLYNOMIAL;
		  else           crc = ( crc << 1 );
		  
		}
	  }
	  
	  return crc;
	}
		
	
	//******************************************************************************************
	// name       :   初始化
	// function   :   
	// definition :  
	//******************************************************************************************	
	void OZ9350_Init( void )
	{
		//OZ9350_SDA_Out_Mode();
		OZ9350_SDA_HIGHT;
		OZ9350_SCK_HIGHT;
		
		// 读 版本寄存器 检查IIC
		OZ9350_Read_Register( OZ9350_0X00H_REGISTER ); 
		
		
		
	}
	
