/**************************************************************************//**

 * 
 ******************************************************************************/
#include "ch32v10x.h"


#ifndef _function_oz9350_H__
#define _function_oz9350_H__


	#define OZ9350_SDA_HIGHT 					GPIO_SetBits(  GPIOA , GPIO_Pin_4  )
	#define OZ9350_SDA_LOW 						GPIO_ResetBits( GPIOA , GPIO_Pin_4 )	
	
	#define OZ9350_SCK_HIGHT 					GPIO_SetBits(  GPIOA , GPIO_Pin_5  )	
	#define OZ9350_SCK_LOW 						GPIO_ResetBits( GPIOA , GPIO_Pin_5 )	

	#define OZ9350_DELAY_L	5
	#define OZ9350_DELAY_M	10
	#define OZ9350_DELAY_H	20


	#define ACK_SEN 1
	#define NACK_SEN 0

	#define OZ9350_ADR 0X48
	#define WRITE_CMD  0X01
	#define READ_CMD   0X00
	
	// #define POLYNOMIAL  0x131 // x8+x5+x4+1 
	#define POLYNOMIAL  0x107 // x8+x2+x1+1 
	
	#define OZ9350_0X00H_REGISTER 		0X00
	#define OZ9350_0X01H_REGISTER 		0X01
	#define OZ9350_0X02H_REGISTER 		0X02
	#define OZ9350_0X03H_REGISTER 		0X03
	#define OZ9350_0X04H_REGISTER 		0X04
	#define OZ9350_0X05H_REGISTER 		0X05
	#define OZ9350_0X06H_REGISTER 		0X06
	
	
	
	//******************************************************************************************
	// name       :         
	// function   :  
	// definition : 
	//******************************************************************************************
	struct OZ9350_ST																																			
	{
		unsigned char Register_Get_Add[6];
		unsigned char Register_Get_Ack[6];
		unsigned char Register_Get_Mess[6];
		unsigned char Register_Get_Crc[6];
		unsigned char Register_Caculat_Crc[6];
		
		unsigned char Register_Sen_Add[6];
		unsigned char Register_Sen_Mess[6];
		unsigned char Register_Sen_Crc[6];	
		
	};
	extern struct OZ9350_ST  OZ9350;

		
	
	//******************************************************************************************
	// name       :            
	// function   :  
	// definition : 
	//******************************************************************************************
	void OZ9350_IIC_Delay( unsigned char delay_time ); 
	
	void OZ9350_IIC_Start(void);
	void OZ9350_IIC_Stop(void);
	void OZ9350_IIC_Write_Byte( unsigned char wr_Data );
	unsigned char OZ9350_IIC_Read_Byte( void );
	
	
	void OZ9350_Sen_Ack_Nack( unsigned char ack_mes );
	unsigned char OZ9350_Get_Ack(void);
	
	void OZ9350_SDA_Input_Mode(void);
	void OZ9350_SDA_Out_Mode(void);
	
	void OZ9350_Read_Register( unsigned char Read_Address  );
	void OZ9350_Write_Register( unsigned char Write_Address , unsigned char Write_Data  );
	
	void OZ9350_Init(void);
	unsigned char OZ9350_CalcCrc( unsigned char data_buff[], unsigned char nbrOfBytes );
	
#endif  
