/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2020/04/30
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
GPIO routine:
 PA0 push-pull output.

*/

#include "debug.h"
#include  "system_mcu_set.h"

#include  "function_project.h"
#include  "function_ssd1306.h"
#include  "function_screen.h"
#include  "function_oz9350.h"

//========================================================================
//========================================================================
//  BMS - CONTORL MCU
//  1: gpio         ok
//  2: time3 isr    ok
//  3: adc   isr
//========================================================================
//========================================================================





//========================================================================
//========================================================================
// ==================  系统时钟选择  =====================================
#define PLL_Source    HSI			// 时钟源选择为HIRC
//#define PLL_Source   HSI_1_2

#define HSI           0    			//HSI
#define HSI_1_2       1    			//HSI/2



//========================================================================
//========================================================================
//========================================================================





/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{


    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	
	SystemInit();
	
    Delay_Init();

	System_Function_Set();		// GPIO TIME3 
	
	Task_Manage_Data_Init();	// Data Init
	
	
    while(1)
    {
        Task_Manage();
    }
}
